
/*
    RFC Framework v0.2.1
    Copyright (C) 2013 CrownSoft
  
    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.
      
*/

#ifndef _RFC_H_
#define _RFC_H_

#include<windows.h>
#include<commctrl.h>

#ifdef _MSC_VER
#pragma comment(lib,"Comctl32.lib")
#endif

#include"config.h"

#include"utils/KPlatformUtil.h"
#include"KApplication.h"
#include"text/KString.h"
#include"graphics/KFont.h"
#include"graphics/KIcon.h"
#include"graphics/KBitmap.h"
#include"graphics/KCursor.h"
#include"gui/KComponent.h"
#include"gui/KWindow.h"
#include"gui/KWindowTypes.h"
#include"gui/KButtonListener.h"
#include"gui/KButton.h"
#include"gui/KLabel.h"
#include"gui/KCheckBox.h"
#include"gui/KRadioButton.h"
#include"gui/KPushButton.h"
#include"gui/KGroupBox.h"
#include"gui/KProgressBar.h"
#include"gui/KMenuItemListener.h"
#include"gui/KMenuItem.h"
#include"gui/KMenu.h"
#include"gui/KMenuBar.h"
#include"gui/KTextBox.h"
#include"gui/KPasswordBox.h"
#include"gui/KTextArea.h"
#include"gui/KListBox.h"
#include"gui/KListBoxListener.h"
#include"gui/KComboBox.h"
#include"gui/KComboBoxListener.h"
#include"gui/KTrackBar.h"
#include"gui/KTrackBarListener.h"
#include"gui/KCommonDialogBox.h"
#include"gui/KNumericField.h"
#include"threads/KThread.h"
#include"threads/KTimer.h"
#include"threads/KTimerListener.h"

RFC_API LRESULT CALLBACK GlobalWnd_Proc(HWND,UINT,WPARAM,LPARAM);
RFC_API BOOL CALLBACK GlobalDlg_Proc(HWND,UINT,WPARAM,LPARAM);
RFC_API DWORD WINAPI GlobalThread_Proc(LPVOID);

RFC_API HWND CreateRFCComponent(KComponent*);
RFC_API bool CreateRFCThread(KThread*);

RFC_API void DoMessagePump(bool handleTabKey=true);

RFC_API void InitRFC(HINSTANCE);
RFC_API void DeInitRFC();

RFC_API int HotPlugAndRunDialogBox(WORD resourceID,HWND parentHwnd,KComponent* component);

#define START_RFC_APPLICATION(AppClass) \
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow) \
{ \
	InitRFC(hInstance);\
	int argc=0;\
	LPWSTR *args=CommandLineToArgvW(GetCommandLineW(),&argc);\
	KString **str_argv=(KString**)malloc(argc*4);\
	for(int i=0;i<argc;i++){str_argv[i]=new KString(args[i]);}\
	AppClass* application=new AppClass();\
	int retVal=application->Main(str_argv,argc);\
	delete application;\
	DeInitRFC();\
	for(int i=0;i<argc;i++){delete str_argv[i];}\
	free((void*)str_argv);\
	GlobalFree(args);\
	return retVal;\
}

// needed for supporting XP/Vista styles.
#ifdef _MSC_VER
#ifndef RFC_DLL
#ifndef RFC_NO_MANIFEST
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='x86' publicKeyToken='6595b64144ccf1df' language='*'\"")
#endif
#endif
#endif

#define BEGIN_KMSG_HANDLER \
	virtual LRESULT WindowProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) \
	{\
	switch(msg)\
	{

#define ON_KMSG(_KMsg,_KMsgHandler) \
	case _KMsg: return _KMsgHandler(wParam,lParam);

#define END_KMSG_HANDLER(_KComponentParentClass) \
	default: return _KComponentParentClass::WindowProc(hwnd,msg,wParam,lParam); \
	}\
	}

#ifndef RFC_NO_UNICODE_STR
#define T(stringLiteral) KString(L##stringLiteral)
#else
#define T(stringLiteral) KString(stringLiteral)
#endif

#endif